#include "tap.h"

#define ID_DEBUGGER 0x80000105

TAP_ID( ID_DEBUGGER );
TAP_PROGRAM_NAME("DEBUGGER");
TAP_AUTHOR_NAME("R.AIGNER(AT)RA-SOFT.COM");
TAP_DESCRIPTION("Debugger Utility");
TAP_ETCINFO(__DATE__);

#include "common_definitions.h"
#include "tap_definitions.h"

bool _exitFlag = FALSE;

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
	int res = 0;
    if(event == EVT_KEY) {
        _exitFlag = TRUE;
	    return 0;
    } else if (event == EVT_UART) {
		if ( param1 == STX_CHAR) {
			res = ReceiveBuffer();
			if (res != -1) {
				DecodePackage();
			}
		} else if ( param1 == BREAK_CHAR) {
			TAP_PutCh(BREAK_CHAR);
		}

		// always clear return value
	    return 0;
	}

	return param1;
}

int TAP_Main(void)
{
    while(_exitFlag == FALSE) {
        TAP_SystemProc();
    }

    return 0;
}


