// stdafx.cpp : source file that includes just the standard includes
//	TopfDebug.pch will be the pre-compiled header
//	stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"





UINT64 GetCurrentUTime()
{
	LARGE_INTEGER l;
	QueryPerformanceCounter(&l);
	return UINT64(l.QuadPart);
}

//------------------------------------------------------------------------------------------------
UINT64 GetPerformanceCounterTicksSince(UINT64 nStart)
{
	UINT64 n = GetCurrentUTime();
	return n < nStart ? _UI64_MAX - nStart + n + 1 : n - nStart;
}

UINT64 GetCurrentTimeMicroSeconds()
{
	LARGE_INTEGER l, nFreq;
	QueryPerformanceCounter(&l);
	QueryPerformanceFrequency(&nFreq);

	UINT64 res = UINT64(l.QuadPart);
	UINT64 count = res / UINT64(nFreq.QuadPart/ 1000 / 1000);

	return count;
}


UINT64 GetCurrentTimeMilliSeconds()
{
	LARGE_INTEGER l, nFreq;
	QueryPerformanceCounter(&l);
	QueryPerformanceFrequency(&nFreq);

	UINT64 res = UINT64(l.QuadPart);
	UINT64 count = res / UINT64(nFreq.QuadPart/ 1000);

	return count;
}

