// TopfDebugView.cpp : implementation of the CTopfDebugView class
//

#include "stdafx.h"
#include "TopfDebug.h"

#include "TopfDebugDoc.h"
#include "TopfDebugView.h"
#include "serial\serial.h"

#include "BufferConverter.h"

CBufferConverter	glob_memory;
CSerial glob_ser;


#include "communicationbase.c"
#include "tap_definitions.h"
#include "topfcommwin.c"

//#undef RGB
#include "topfieldAPI\tap.h"

#include "stap_windows.c"
#include "atap_windows.c"
#include "tap_windows.c"





#include "TopfieldApplication\build.c"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTopfDebugView

IMPLEMENT_DYNCREATE(CTopfDebugView, CView)

BEGIN_MESSAGE_MAP(CTopfDebugView, CView)
	//{{AFX_MSG_MAP(CTopfDebugView)
	ON_COMMAND(ID_GOSIM, OnGosim)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTopfDebugView construction/destruction

CTopfDebugView::CTopfDebugView()
{
	// TODO: add construction code here

}

CTopfDebugView::~CTopfDebugView()
{
}

BOOL CTopfDebugView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTopfDebugView drawing

void CTopfDebugView::OnDraw(CDC* pDC)
{
	CTopfDebugDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CTopfDebugView diagnostics

#ifdef _DEBUG
void CTopfDebugView::AssertValid() const
{
	CView::AssertValid();
}

void CTopfDebugView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTopfDebugDoc* CTopfDebugView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTopfDebugDoc)));
	return (CTopfDebugDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTopfDebugView message handlers

void CTopfDebugView::OnGosim() 
{
	// TODO: Add your command handler code here
	if (glob_ser.Open("com1") == ERROR_SUCCESS) {

		glob_ser.Setup(CSerial::EBaud115200,CSerial::EData8,CSerial::EParNone,CSerial::EStop2);
		glob_ser.SetupHandshaking(CSerial::EHandshakeSoftware);
		glob_ser.SetupReadTimeouts(CSerial::EReadTimeoutBlocking);	

//		LONG l = 0x12345678;
//		WORD w = 0x1234;
//		glob_memory.SwapLong(&l);
//		glob_memory.SwapWord(&w);
//
//		glob_memory.SwapLong(&l);
//		glob_memory.SwapWord(&w);
//


//		INT64 u = 0x12345678;
//		u = u << 32;
//		u = u +   0x98765432;
//
//		glob_memory.SwapULong64((ulong64*)&u);
//		glob_memory.SwapULong64((ulong64*)&u);

	
		TAP_Main();

		glob_ser.Close();
	} else {
		AfxMessageBox("Cannot open serial port for debugger");
	}
}

int CTopfDebugView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	PostMessage(WM_COMMAND, ID_GOSIM, 0L);

	return 0;
}
